Imports KS.Gantt

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Not DesignMode Then
            Font = SystemFonts.IconTitleFont
        End If

        Me.Gantt1.ShowIcons = False
        Me.Gantt1.SelectionMode = KS.Gantt.Gantt.SelectionModes.MultipleSelection

        Me.Gantt1.StartDate = DateTime.Now.AddMonths(0)
        Me.Gantt1.EndDate = DateTime.Now.AddMonths(2)


        Dim col As GanttDataColumn
        col = Me.GanttDataGrid1.TaskColumns.Add("MyColumn", "My Column")
        col.EditType = GanttEditTypes.DropDownList
        col.AddValueListItem("", Nothing)
        col.AddValueListItem("Banana", 1)
        col.AddValueListItem("Tomato", 2)
        col.AddValueListItem("Orange", 3)

        Gantt1.SuspendItemLayout()

        Dim resource1 As ResourceItem = Me.Gantt1.AddResource("Detlef Kroll", "Developer", 100.0)
        Dim resource2 As ResourceItem = Me.Gantt1.AddResource("Thomas Thompson", "Project-Manager", 140.0)
        Dim resource3 As ResourceItem = Me.Gantt1.AddResource("David Stevens", "Marketing", 75.0)
        Dim resource4 As ResourceItem = Me.Gantt1.AddResource("Richard Reed", "Office", 48.0)

        ' Now add some tasks and groups and relations

        Dim bar1 As TaskItem
        bar1 = Me.Gantt1.AddTask(New DateTime(2015, 1, 2), New DateTime(2015, 1, 20), "TaskItem 1")
        bar1.PercentDone = 0.82
        bar1.AddResource(resource1, 0.5)
        bar1.AddResource(resource2, 0.5)
        bar1.AddResource(resource3, 0.7)    
        bar1.Status = TaskItem.TaskStates.Running
        bar1.Priority = TaskItem.TaskPriorities.High
        bar1.SetProperty("MyColumn", "Value 1")

        Dim bar2 As TaskItem
        bar2 = Me.Gantt1.AddTask(New DateTime(2015, 1, 22), New DateTime(2015, 2, 27), "TaskItem 2")
        bar2.PercentDone = 0.63        
        bar2.AddResource(resource1, 0.5)
        bar2.AddResource(resource2, 0.7)
        bar2.AddDependence(bar1, 5)
        bar2.Status = TaskItem.TaskStates.Running
        bar2.Priority = TaskItem.TaskPriorities.Lower
        bar2.SetProperty("MyColumn", "Value 2")

        Dim bar3 As TaskItem
        bar3 = Me.Gantt1.AddTask(New DateTime(2015, 1, 12), New DateTime(2015, 2, 20), "TaskItem 3")
        bar3.PercentDone = 0.33        
        bar3.AddResource(resource1, 0.5)
        bar3.AddResource(resource2, 0.3)
        bar3.AddResource(resource3, 0.8)
        bar3.AddDependence(bar2)
        bar3.Status = TaskItem.TaskStates.Paused
        bar3.Priority = TaskItem.TaskPriorities.Higher

        Dim bar4 As TaskItem
        bar4 = Me.Gantt1.AddTask(New DateTime(2015, 3, 5), New DateTime(2015, 3, 20), "TaskItem 4")
        bar4.PercentDone = 0.3        
        bar4.AddResource(resource1, 0.5)
        bar4.AddResource(resource3, 0.9)
        bar4.AddDependence(bar3)
        bar4.Status = TaskItem.TaskStates.Waiting
        bar4.Priority = TaskItem.TaskPriorities.High

        Dim bar4a As TaskItem
        bar4a = Me.Gantt1.AddTask(New DateTime(2015, 3, 21), New DateTime(2015, 3, 21), "Milestone 1")
        bar4a.IsMilestone = True        
        bar4a.AddDependence(bar4)


        Dim bar5 As TaskItem
        bar5 = Me.Gantt1.AddTask(New DateTime(2015, 4, 5), New DateTime(2015, 4, 12), "TaskItem 5")
        bar5.PercentDone = 0.3        
        bar5.AddResource(resource1, 0.5)
        bar5.Status = TaskItem.TaskStates.Waiting
        bar5.Priority = TaskItem.TaskPriorities.Normal

        Dim bar6 As TaskItem
        bar6 = Me.Gantt1.AddTask(New DateTime(2015, 4, 15), New DateTime(2015, 4, 22), "TaskItem 6")
        bar6.PercentDone = 0.3        
        bar6.AddResource(resource1, 0.5)
        bar6.AddResource(resource4, 0.6)
        bar6.AddDependence(bar5)
        bar6.Status = TaskItem.TaskStates.Paused
        bar6.Priority = TaskItem.TaskPriorities.Lower

        Dim bar7 As TaskItem
        bar7 = Me.Gantt1.AddTask(New DateTime(2015, 4, 22), New DateTime(2015, 5, 3), "TaskItem 7")
        bar7.PercentDone = 0.3        
        bar7.AddResource(resource1, 0.5)
        bar7.AddResource(resource4, 0.7)
        bar7.AddDependence(bar6)
        bar7.Status = TaskItem.TaskStates.Steady
        bar7.Priority = TaskItem.TaskPriorities.Higher

        Dim bar8 As TaskItem
        bar8 = Me.Gantt1.AddTask(New DateTime(2015, 5, 5), New DateTime(2015, 5, 16), "TaskItem 8")
        bar8.PercentDone = 0.3        
        bar8.AddResource(resource1, 0.5)
        bar8.AddResource(resource4, 0.3)
        bar8.AddResource(resource3, 0.6)
        bar8.AddDependence(bar7)
        bar8.Status = TaskItem.TaskStates.Steady
        bar8.Priority = TaskItem.TaskPriorities.Normal

        Dim gi1 As GroupItem
        gi1 = Gantt1.AddGroup("Group 1")
        gi1.AddChild(Gantt1.Tasks(0))
        gi1.AddChild(Gantt1.Tasks(1))
        gi1.AddChild(Gantt1.Tasks(2))
        gi1.AddChild(Gantt1.Tasks(3))
        gi1.AddChild(Gantt1.Tasks(4))

        Dim gi2 As GroupItem
        gi2 = Gantt1.AddGroup("Group 2")
        gi2.AddChild(Gantt1.Tasks(5))
        gi2.AddChild(Gantt1.Tasks(6))
        gi2.AddChild(Gantt1.Tasks(7))
        gi2.AddChild(Gantt1.Tasks(8))

        Dim gi0 As GroupItem
        gi0 = Gantt1.AddGroup("Group 0")
        gi0.AddChild(gi1)
        gi0.AddChild(gi2)

        Dim bar9 As TaskItem
        bar9 = Me.Gantt1.AddTask(New DateTime(2015, 5, 5), New DateTime(2015, 5, 16), "TaskItem 9")
        bar9.PercentDone = 0.3        
        bar9.AddResource(resource1, 0.5)
        bar9.AddResource(resource4, 0.3)
        bar9.AddResource(resource3, 0.6)
        bar9.Status = TaskItem.TaskStates.Done
        bar9.Priority = TaskItem.TaskPriorities.High

        Dim bar10 As TaskItem
        bar10 = Me.Gantt1.AddTask(New DateTime(2015, 4, 1), New DateTime(2015, 4, 16), "TaskItem 10")
        bar10.PercentDone = 0.3        
        bar10.AddResource(resource1, 0.8)
        bar10.AddResource(resource4, 0.2)
        bar10.Status = TaskItem.TaskStates.Steady
        bar10.Priority = TaskItem.TaskPriorities.Normal

        Dim gi3 As GroupItem
        gi3 = Gantt1.AddGroup("Group 3")
        gi3.AddChild(bar9)

        gi1.AddChild(gi3)

        Dim gi4 As GroupItem
        gi4 = Gantt1.AddGroup("Group 4")
        gi4.AddChild(bar9)
        gi1.AddChild(gi4)

        Dim bar11 As TaskItem
        bar11 = Me.Gantt1.AddTask(New DateTime(2015, 5, 1), New DateTime(2015, 5, 16), "TaskItem 11")
        bar11.PercentDone = 0.3        
        bar11.AddResource(resource1, 0.8)
        bar11.AddResource(resource4, 0.2)
        bar11.Status = TaskItem.TaskStates.Steady
        bar11.Priority = TaskItem.TaskPriorities.Normal

        Dim bar12 As TaskItem
        bar12 = Me.Gantt1.AddTask(New DateTime(2015, 5, 17), New DateTime(2015, 5, 30), "TaskItem 12")
        bar12.PercentDone = 0.3        
        bar12.AddResource(resource1, 0.8)
        bar12.AddResource(resource4, 0.2)
        bar12.Status = TaskItem.TaskStates.Steady
        bar12.Priority = TaskItem.TaskPriorities.Normal

        Dim bar13 As TaskItem
        bar13 = Me.Gantt1.AddTask(New DateTime(2015, 6, 1), New DateTime(2015, 6, 16), "TaskItem 13")
        bar13.PercentDone = 0.3        
        bar13.AddResource(resource1, 0.8)
        bar13.AddResource(resource4, 0.2)
        bar13.Status = TaskItem.TaskStates.Steady
        bar13.Priority = TaskItem.TaskPriorities.Normal

        ' Circular Dependency
        bar12.AddDependence(bar11)
        bar13.AddDependence(bar12)
        bar11.AddDependence(bar13)

        ' gantt1.EnsureItemVisible(bar11);

        Me.Gantt1.AutoMoveItems()
        Me.Gantt1.ZoomToFit()
        Me.Gantt1.ResumeItemLayout()
        Me.Gantt1.Focus()

    End Sub


    Private Sub Gantt1_Enter(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.PropertyGrid1.SelectedObject = Me.Gantt1
    End Sub

    Private Sub GanttDataGrid1_Enter(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.PropertyGrid1.SelectedObject = Me.GanttDataGrid1
    End Sub

    Private Sub Gantt1_BeforeDelete(ByVal sender As Object, ByVal e As KS.Gantt.GanttCancelEventArgs)
        If MessageBox.Show(Me, "Do you really want to delete " & Gantt1.SelectedItems.Count.ToString() & " selected items ?", "Gantt Demo", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question) <> Windows.Forms.DialogResult.Yes Then
            e.Cancel = True
        End If
    End Sub

    
    Private Sub Gantt1_ItemDoubleClick(ByVal sender As System.Object, ByVal e As KS.Gantt.GanttItemMouseEventArgs)
        Gantt1.EditItem(e.Item)
    End Sub

    Private Sub Gantt1_MovingItem(ByVal sender As System.Object, ByVal e As KS.Gantt.GanttItemEventArgs)
        ShowItemStatus(e.Item)
    End Sub

    Private Sub Gantt1_ItemsMoved(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ShowItemStatus(Nothing)
    End Sub

    Private Sub Gantt1_ItemsResized(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ShowItemStatus(Nothing)
    End Sub

    Private Sub Gantt1_ItemHover(ByVal sender As System.Object, ByVal e As KS.Gantt.GanttItemEventArgs)
        ShowItemStatus(e.Item)
    End Sub


    Private Sub ShowItemStatus(ByVal item As GanttItem)
        If item Is Nothing Then
            toolStripStatusLabelTaskName.Text = ""
            toolStripStatusLabelStartDate.Text = ""
            toolStripStatusLabelEndDate.Text = ""
            toolStripStatusLabelDuration.Text = ""
        Else
            toolStripStatusLabelTaskName.Text = item.Text
            toolStripStatusLabelStartDate.Text = item.StartDateForDisplay
            toolStripStatusLabelEndDate.Text = item.EndDateForDisplay
            toolStripStatusLabelDuration.Text = item.DurationForDisplay
        End If
    End Sub

    
End Class
