using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ProjectPlanner.SqlServer
{
    public partial class SqlServerConnectDialog : Form
    {   
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public bool ServerEnabled
        {
            get
            {
                return this.ucSqlServerConnect1.cboServer.Enabled;
            }
            set
            {
                this.ucSqlServerConnect1.cboServer.Enabled = value;
            }
        }

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public bool DatabaseEnabled
        {
            get
            {
                return this.ucSqlServerConnect1.cboDatabase.Enabled;
            }
            set
            {
                this.ucSqlServerConnect1.cboDatabase.Enabled = value;
            }
        }

        public SqlServerConnectDialog()
        {            
            InitializeComponent();

            if (!DesignMode)            
                this.Font = SystemFonts.IconTitleFont;            
        }

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public string UserName
		{
			get
            {
				return ucSqlServerConnect1.UserName;
			}
			set
			{
				ucSqlServerConnect1.UserName = value;
			}
		}

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public string Password
		{
			get
            {
                return ucSqlServerConnect1.Password;
			}
			set
			{
                ucSqlServerConnect1.Password = value;
			}
		}

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public string Server
		{
			get
            {
                return ucSqlServerConnect1.Server;
			}
			set
			{
                ucSqlServerConnect1.Server = value;
			}
		}

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public string Database
		{
			get
            {
                return ucSqlServerConnect1.Database;
			}
			set
			{
                ucSqlServerConnect1.Database = value;
			}
		}

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public SQLAuthTypes SQLAuth
		{
			get
            {				
                return ucSqlServerConnect1.SQLAuth;
			}
			set
			{
                ucSqlServerConnect1.SQLAuth = value;
			}
		}

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public int ConnectionTimeout
        {
            get
            {
                return ucSqlServerConnect1.ConnectionTimeout;
            }
            set
            {
                ucSqlServerConnect1.ConnectionTimeout = value;
            }
        }

		public string ConnectionString
		{
			get
            {
                return ucSqlServerConnect1.ConnectionString;
			}
		}

        private void SqlServerConnectDialog_Load(object sender, EventArgs e)
        {
            this.DialogResult = System.Windows.Forms.DialogResult.None;
        }

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);
            ucSqlServerConnect1.InitLoad();

            if (ucSqlServerConnect1.radAuthSQL.Checked && ucSqlServerConnect1.txtUser.Text != "" && ucSqlServerConnect1.txtPassword.Text == "")
                ucSqlServerConnect1.txtPassword.Focus();
            else
                cmdOK.Focus();
        }

        
        private void cmdOK_Click(object sender, EventArgs e)
        {
            if (!ucSqlServerConnect1.IsValid(true, true))
            {
                return;
            }
            
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.Close();
        }
                

        private void cmdTestConnection_Click(object sender, EventArgs e)
        {
            ucSqlServerConnect1.TestConnection();
        }               
    }
}