using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Reflection;

namespace ResourcePlanner
{
    public partial class frmAbout : Form
    {
        public frmAbout()
        {            
            InitializeComponent();

            if (!this.DesignMode)
                this.Font = SystemFonts.IconTitleFont;

            this.LinkURL.Click += new EventHandler(LinkURL_Click);
        }        

        private void frmAbout_Load(object sender, EventArgs e)
        {
            Assembly a = typeof(ResourcePlanner.Program).Assembly;
            System.Version v = a.GetName().Version;
            string strVersion = v.Major + "." + v.Minor + "." + v.Build;

            if (v.Revision > 0)
            {
                strVersion += " - Revision " + v.Revision;
            }

            if (Program.VersionSuffix != "")
                strVersion += " " + Program.VersionSuffix;

            lblVersion.Text = "Version " + strVersion;
        }

        void LinkURL_Click(object sender, EventArgs e)
        {
            try
            {
                Process.Start("http://www.kroll-software.ch");
            }
            catch (Exception ex)
            {
                Program.ErrMsgBox(ex.Message);
            }
        }

        private void cmdOK_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}